#include <kihon.h>

// XvCg̃_uobt@AhX̏ʃoCg
#define SPRITE_BUF_ADR	0x06	// 0x0600?0x07FF̏ꍇ

// XvCg̃obt@؂ւ}N
//  \p̃obt@AhXpƂă|C^ϐɐݒ
//  DMAw̒l̍ŉʃrbĝݔ]ĕ\p̃obt@ݒ
#define SPRITE_SWAP_BUF(dma, sprite_buf_adr) \
	((unsigned char *)&sprite_buf_adr)[0] = 0x00, \
	((unsigned char *)&sprite_buf_adr)[1] = dma, \
	dma = (~dma & 1) + SPRITE_BUF_ADR;

// Ԕԍ
enum {
	SYNC_NOTHING = 0,
	SYNC_READY,
	SYNC_BUSY
};

// 256oCg̃pbgf[^16FPgŎg2zƂĐ錾
extern const unsigned char palette[16][16];

typedef struct {
	unsigned char sync;	// Ԓl
	unsigned char dma;	// DMA]s\pXvCgobt@AhX̏ʃoCg
	unsigned char* sprite_buf_adr;	// pXvCgobt@̃AhX
} Work;

extern Work zpw;
#pragma zpsym ("zpw");     /* zpw is in the zeropage */

// C
void NesMain(void) {
	// ϐ
	zpw.sync = SYNC_NOTHING;
	zpw.dma = SPRITE_BUF_ADR;

	// PPȔ
	InitPPU();

	// XvCg̏
	//   p̃obt@؂ւă_uobt@Ŝ
	SPRITE_SWAP_BUF(zpw.dma, zpw.sprite_buf_adr);
	InitDMA(zpw.sprite_buf_adr);
	SPRITE_SWAP_BUF(zpw.dma, zpw.sprite_buf_adr);
	InitDMA(zpw.sprite_buf_adr);

	// BG̏
	//     0                256            511
	//   0 + 0x2000 --------+ 0x2400 --------+
	//     |                |                |
	// 240 + 0x2800 --------+ 0x2C00 --------+
	//     |                |                |
	// 279 +----------------+----------------+
	//  Horizontal mirroring: 0x2000$2400A0x28000x2C00~[AhX
	//  Vertical mirroring  : 0x2000$2800A0x24000x2C00~[AhX
	FillBackground(0x20, 0x00, 0x00, 0);
	FillBackground(0x21, 0x00, 0x00, 0);
	FillBackground(0x22, 0x00, 0x00, 0);
	FillBackground(0x23, 0x00, 0x00, 0xC0);
	FillAttribute(0x23, 0xC0, 0x00, 0x40);

	// Vertical mirroring̏ꍇAʉE
	FillBackground(0x24, 0x00, 0x00, 0);
	FillBackground(0x25, 0x00, 0x00, 0);
	FillBackground(0x26, 0x00, 0x00, 0);
	FillBackground(0x27, 0x00, 0x00, 0xC0);
	FillAttribute(0x27, 0xC0, 0x00, 0x40);

	// Horizontal mirroring̏ꍇAʍ
	FillBackground(0x28, 0x00, 0x00, 0);
	FillBackground(0x29, 0x00, 0x00, 0);
	FillBackground(0x2A, 0x00, 0x00, 0);
	FillBackground(0x2B, 0x00, 0x00, 0xC0);
	FillAttribute(0x2B, 0xC0, 0x00, 0x40);

	//// pbgݒ
	SetPalette(palette[0], 0);
	SetPalette(palette[1], 1);

	//// XN[l̐ݒ
	SetScroll(0, 0);

	// `Jn(NMI荞ݗLAXvCgTCY8x16AXvCg\ABG\)
	SetPPU(0xA0, 0x1E);

	// XvCg̐ݒ
	SetDMA(zpw.sprite_buf_adr, 1, 8, 80, 0x1E, 0);	// ZERO BOMB (x,y)=(8,80)

	// C[v
	while (1) {
		//// VBlankJnݒ
		zpw.sync = SYNC_READY;

		//// VBlank҂
		while (zpw.sync);

		////// LN^ړȂǂ̃C




		//// XvCg̐ݒ
		SetDMA(zpw.sprite_buf_adr, 1, 8, 80, 0x1E, 0);	// ZERO BOMB (x,y)=(8,80)

		////// LN^\XvCg̐ݒ
		SetDMA(zpw.sprite_buf_adr, 0, 8, 80, 0x03, 0);


	}
}

// NMI荞
void NMIProc(void) {
	//// VBlankJn҂
	if (zpw.sync != SYNC_READY) {
		//// JnÔ߁ABGƃXvCg̍XVȂB
		//// ɂAKvŒ̏sĊ荞ݏI

#ifdef USE_ZERO_BOMB
		//// XvCg̍ē]
		////   XvCgobt@̐؂ւÔ߁AOƓf[^]
		////   0ԃXvCg\̌osꍇ͕K{
		SendDMA(zpw.dma);

		//// XN[ʒu̐ݒ
		////  ʏ㕔XN[ꍇ́AŃXN[lύX
		SetScroll(0, 0);

		//// 0ԃXvCg\o
		ZeroSprite();

		//// XN[ʒu̍Đݒ
		////  ʉXN[ꍇ́AŃXN[lύX
		SetScroll(0, 0);
#endif
		return;
	}

	//// VBlankJn
	zpw.sync = SYNC_BUSY;

	//// XvCgobt@̐؂ւ
	SPRITE_SWAP_BUF(zpw.dma, zpw.sprite_buf_adr);

	//// XvCg]
	SendDMA(zpw.dma);

	//// BG
	*REGIST_ADR = AhX̏ʃoCg;
	*REGIST_ADR = AhX̉ʃoCg;
	*REGIST_GRA = ݒl;
	*REGIST_GRA = ݒl;
						:

	//// BG\ꎞ~
	////  pbgBGӏꍇ͉ʂ邽
	SetPPU(0xA0, 0x16);

	//// wiFpbg
	*REGIST_ADR = AhX̏ʃoCg;
	*REGIST_ADR = AhX̉ʃoCg;
	*REGIST_GRA = ݒl;
	*REGIST_GRA = ݒl;
						:

	//// BG\ĊJ
	SetPPU(0xA0, 0x1E);

	//// XN[ʒu̐ݒ
	////  BGpbgύXꍇ́AKĐݒ肷邱
	////  ʏ㕔XN[ꍇ́AŃXN[lύX
	SetScroll(0, 0);

#ifdef USE_ZERO_BOMB
	//// 0ԃXvCg\o
	////  PPU`撆CPUŊĎ邽߁A`ȊȌԂȂ悤
	////  \ołȂꍇ͖[vɂȂ܂I
	////  ʂ̉̕ŃXN[ʒuωꍇ́AɃC[vŕ\҂邱
	ZeroSprite();

	//// XN[ʒu̍Đݒ
	////  ʉXN[ꍇ́AŃXN[lύX
	SetScroll(0, 0);
#endif

	//// VBlank
	zpw.sync = SYNC_NOTHING;
}
